unit CatalogMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, DB, SqlExpr, Grids, DBGrids,
{$IfDef CA400static}
  dbexpca400, MidasLib,
{$EndIf}
  StdCtrls, Provider, DBClient;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    SQLConnection1: TSQLConnection;
    CatalogQuery: TSQLQuery;
    View: TButton;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DataSetProvider1: TDataSetProvider;
    CatalogText: TMemo;
    RetrieveBox: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LibraryBox: TComboBox;
    FileBox: TComboBox;
    MemberBox: TComboBox;
    PackageBox: TComboBox;
    Label5: TLabel;
    Label8: TLabel;
    FieldBox: TComboBox;
    FileTypeBox: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    FileAttrBox: TComboBox;
    FormatBox: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    LongFileBox: TComboBox;
    Label11: TLabel;
    RDBBox: TComboBox;
    Label12: TLabel;
    PrimaryKeyFileBox: TComboBox;
    PrimaryKeyLibBox: TComboBox;
    Label13: TLabel;
    ForeignKeyFileBox: TComboBox;
    Label14: TLabel;
    Label15: TLabel;
    ForeignKeyLibBox: TComboBox;
    procedure ViewClick(Sender: TObject);
    procedure BoxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ViewClick(Sender: TObject);
begin
  ClientDataset1.Active:= False;
  CatalogQuery.SQL.Text:= CatalogText.Text;
  ClientDataset1.Active:= True
end;

procedure TForm1.BoxChange(Sender: TObject);
Var
  Topic, Value: String;
  p: Integer;
  s: String;
begin
  If Not (Sender Is TComboBox) Then
    Exit;
  Topic:= (Sender As TComboBox).Name;
  Value:= Trim((Sender As TComboBox).Text);
  p:= Pos('BOX', UpperCase(Topic));
  If p>0 Then
    SetLength(Topic, p-1);

  p:= Pos(' '+UpperCase(Topic)+'(', UpperCase(CatalogText.Text));
  If p=0 Then Begin
    If Value<>'' Then
      CatalogText.Text:= Format('%s %s(%s)', [Trim(CatalogText.Text), Topic, Value])
  End Else Begin
    s:= CatalogText.Text;
    Delete(s,1, p+Length(Topic));
    Delete(s,1,Pos(')', s));
    If Value='' Then
      CatalogText.Text:= Format('%s %s', [Trim(Copy(CatalogText.Text,1, p-1)), s])
    Else
      CatalogText.Text:= Format('%s %s(%s) %s', [Trim(Copy(CatalogText.Text,1, p-1)), Topic, Value, s])
  End
end;

end.
