unit DataLinkMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, DB, SqlExpr, Grids, DBGrids,
  dbexpca400, StdCtrls, Provider, DBClient, ExtCtrls, DBCtrls;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DataSetProvider1: TDataSetProvider;
    ExecQuery: TSQLQuery;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OpenBtn: TButton;
    SelectDinos: TMemo;
    CreateDinos: TMemo;
    CreateBtn: TButton;
    InsertBtn: TButton;
    InsertDino: TMemo;
    Open2Btn: TButton;
    SelectDinosEnhanced: TMemo;
    procedure OpenBtnClick(Sender: TObject);
    procedure CreateBtnClick(Sender: TObject);
    procedure InsertBtnClick(Sender: TObject);
    procedure Open2BtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.OpenBtnClick(Sender: TObject);
begin
  ClientDataset1.Active:= False;
  SQLQuery1.SQL.Text:= SelectDinos.Text;
  ClientDataset1.Active:= True;
end;

procedure TForm1.Open2BtnClick(Sender: TObject);
begin
  ClientDataset1.Active:= False;
  SQLQuery1.SQL.Text:= SelectDinosEnhanced.Text;
  ClientDataset1.Active:= True;
end;

procedure TForm1.CreateBtnClick(Sender: TObject);
begin
  ExecQuery.SQL.Text:= CreateDinos.Text;
  ExecQuery.ExecSQL;
end;

procedure TForm1.InsertBtnClick(Sender: TObject);
Var
  Count: Integer;
begin
  ExecQuery.SQL.Text:= InsertDino.Text;
  Count:= ExecQuery.ExecSQL;
  MessageDlg(Format('%d rows affected', [Count]), mtInformation, [mbOk], 0);
end;

end.
