unit Test400Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, DBCtrls, Provider, DBClient, DB, SqlExpr,
  Buttons, StdCtrls, Grids, DBGrids, ExtCtrls,
  DbExpCa400, SimpleDS;

type
  TTest400Form = class(TForm)
    CmdPanel: TPanel;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    edAS400: TEdit;
    Label2: TLabel;
    edUser: TEdit;
    Label3: TLabel;
    edPassword: TEdit;
    mnQuery: TMemo;
    Label4: TLabel;
    OpenBtn: TSpeedButton;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    ApllyButton: TSpeedButton;
    Log: TMemo;
    Splitter1: TSplitter;
    SQLMonitor1: TSQLMonitor;
    Mon: TCheckBox;
    SimpleDataSet1: TSimpleDataSet;
    procedure OpenBtnClick(Sender: TObject);
    procedure ApllyButtonClick(Sender: TObject);
    procedure SQLMonitor1LogTrace(Sender: TObject; CBInfo: pSQLTRACEDesc);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Test400Form: TTest400Form;

implementation

{$R *.dfm}

procedure TTest400Form.OpenBtnClick(Sender: TObject);
begin
  If Trim(edAS400.Text)='' Then edAS400.Text:= '*';
  SimpleDataset1.Active:= False;
  //SimpleDataset1.Connection.Connected:= false;
  SimpleDataset1.Connection.Params.Values['DATABASE']:= Trim(edAS400.Text);
  SimpleDataset1.Connection.Params.Values['USER_NAME']:= Trim(edUser.Text);
  SimpleDataset1.Connection.Params.Values['PASSWORD']:= Trim(edPassword.Text);
  SimpleDataset1.DataSet.CommandText:= mnQuery.Lines.Text;
  // SQLQuery1.Params[0].AsString := 'TX';
  SQLMonitor1.Active:= False;
  SQLMonitor1.SQLConnection:= SimpleDataset1.Connection;
  SQLMonitor1.Active:= Mon.Checked;
  SimpleDataset1.Active:= True;
end;

procedure TTest400Form.ApllyButtonClick(Sender: TObject);
begin
  SimpleDataset1.ApplyUpdates(0)
end;

procedure TTest400Form.SQLMonitor1LogTrace(Sender: TObject;
  CBInfo: pSQLTRACEDesc);
begin
  Log.Lines:= SQLMonitor1.TraceList;
end;

end.
